#include "Picture.h"
#include<iostream>
#include<fstream>
#include<string>

using namespace std;

Picture::Picture(string fileName)
{
	ifstream fin(fileName, ios_base::binary);
	if (!fin.fail())
	{
		fin.read(fileHeader.headerField, 2);
		fin.read((char*)&fileHeader.size, 4);
		fin.read((char*)&fileHeader.reserved1, 2);
		fin.read((char*)&fileHeader.reserved2, 2);
		fin.read((char*)&fileHeader.pixelOffset, 4);

		fin.read((char*)&imageHeader.imageHeaderSize, 4);
		fin.read((char*)&imageHeader.width, 4);
		fin.read((char*)&imageHeader.height, 4);
		fin.read((char*)&imageHeader.colorPlanes, 2);
		fin.read((char*)&imageHeader.bitsPerPixel, 2);
		fin.read((char*)&imageHeader.compressionMethod, 4);
		fin.read((char*)&imageHeader.imageSize, 4);
		fin.read((char*)&imageHeader.horizontalResolution, 4);
		fin.read((char*)&imageHeader.verticalResolution, 4);
		fin.read((char*)&imageHeader.colorsInPalette, 4);
		fin.read((char*)&imageHeader.importantColors, 4);

		//read the pixels
		//fin.seekg(54);
		pixels = new Pixel[imageHeader.width * imageHeader.height];
		for (int i = 0; i < imageHeader.width * imageHeader.height;i++)
		{
			//fin.read((char*)&(pixels[i].blue), 1);
			//fin.read((char*)&(pixels[i].green), 1);
			//fin.read((char*)&(pixels[i].red), 1);			
			fin.read((char*)&(pixels[i]), 3);
		}
	}
	else
	{
		cout << "Unable to find the file named " << fileName << endl;
	}
	fin.close();
}


void Picture::saveToFile(std::string fileName)
{
	ofstream fout(fileName, ios_base::binary);
	fout.write(fileHeader.headerField, 2);
	fout.write((char*)&fileHeader.size, 4);
	fout.write((char*)&fileHeader.reserved1, 2);
	fout.write((char*)&fileHeader.reserved2, 2);
	fout.write((char*)&fileHeader.pixelOffset, 4);

	fout.write((char*)&imageHeader.imageHeaderSize, 4);
	fout.write((char*)&imageHeader.width, 4);
	fout.write((char*)&imageHeader.height, 4);
	fout.write((char*)&imageHeader.colorPlanes, 2);
	fout.write((char*)&imageHeader.bitsPerPixel, 2);
	fout.write((char*)&imageHeader.compressionMethod, 4);
	fout.write((char*)&imageHeader.imageSize, 4);
	fout.write((char*)&imageHeader.horizontalResolution, 4);
	fout.write((char*)&imageHeader.verticalResolution, 4);
	fout.write((char*)&imageHeader.colorsInPalette, 4);
	fout.write((char*)&imageHeader.importantColors, 4);

	//write the pixels
	for (int i = 0; i < imageHeader.width * imageHeader.height;i++)
	{
		fout.write((char*)&(pixels[i]), 3);
	}
	fout.close();
}

Picture::~Picture()
{
	if (pixels!= NULL)
	{
		delete[] pixels;
		pixels = NULL;
	}
	cout << "a picture object will die soon" << endl;
}

void Picture::display()
{
	fileHeader.display();
	imageHeader.display();
}


void FileHeader::display()
{
	cout << headerField[0] << headerField[1] << endl;
	cout << size << endl;
	cout << reserved1 << endl;
	cout << reserved2 << endl;
	cout << pixelOffset << endl;
}


void ImageHeader::display()
{
	cout << imageHeaderSize << endl;
	cout << width << endl;
	cout << height << endl;
	cout << colorPlanes << endl;//1
	cout << bitsPerPixel << endl; //24
	cout << compressionMethod << endl;
	cout << imageSize << endl;
	cout << horizontalResolution << endl;
	cout << verticalResolution << endl;
	cout << colorsInPalette << endl;
	cout << importantColors << endl;//0
}

void Picture::invertColors()
{
	for (int i = 0; i < imageHeader.width * imageHeader.height;i++)
	{
		pixels[i].blue = 255-pixels[i].blue;
		pixels[i].green = 255 - pixels[i].green;
		pixels[i].red = 255 - pixels[i].red;
	}
}

